#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell-event.h"
#include "rof-event.h"

using namespace std;

// ܓxEoxEox30b̒EőlEԒlEŏlE[̃Obhǂ߂B
// 30b(1km)f̊iqTCYłBlatitude(ܓx)̃ObhTCY͖111.2kmœłB
// longitude(ox)̃TCY͈ܓxɂĈقȂ̂ŌvZKvB

// vZł͍łk()̍s0sƍlĂB(20120211)

void Cell::setElevation (
	int rowStep, // row counter
	int colStep, // column counter
	int nRow, // number of row for the study area
	int nCol, //number of column for the study area
	float SWlat, // South west corner of latitude
	float SWlon, // South west corner of longitude
	float medElevation // elevation at grid center
)
{
	int numberOfGrid =1; // ̃Obh\Z
	
	// setting latitude in 'sec' unit
	latitude  = (SWlat*3600) + 30*numberOfGrid*(nRow-rowStep-1) + 15*numberOfGrid;

	// setting longitude in 'sec' unit
	longitude = (SWlon*3600) + 30*numberOfGrid*colStep + 15*numberOfGrid;

	// setting length (km) for 1 degree in longitude direction
	longitudinalLength = (float)926.6*(float)cos(latitude/3600.0/180.0*3.14);

	med = medElevation;
	
	if (rowStep==0 || rowStep==nRow-1 || colStep==0 || colStep==nCol-1) {
		isThisGridEnd = true; //Obh̒[ɂ
		gridKind = -1; // edge of study region. Added on May 20, 2013.
	}
	else {
		isThisGridEnd = false;
		gridKind = 1;  // inside of study region. Added on May 20, 2013.
	}
}

/* EאڃObhEObh */
void Cell::setNULL()
{
	down=10;

	downStreamGrid=NULL;
	for(int i=0; i<7; i++) upStreamGrid[i]=NULL;
	ROFCell=NULL;
}


/* o"downStreamGrid"ɒl */
void Cell::setDownStreamGrid(int row, int col, class Cell** cell2)
{
	switch(down){
	case 1:	downStreamGrid = &cell2[row-1][col];
		break;
		
	case 2:	downStreamGrid = &cell2[row-1][col+1];
		break;
		
	case 3:	downStreamGrid = &cell2[row][col+1];
		break;
		
	case 4: downStreamGrid = &cell2[row+1][col+1];
		break;
		
	case 5: downStreamGrid = &cell2[row+1][col];
		break;
		
	case 6: downStreamGrid = &cell2[row+1][col-1];
		break;
		
	case 7: downStreamGrid = &cell2[row][col-1];
		break;
		
	case 8: downStreamGrid = &cell2[row-1][col-1];
		break;
		
	default: break;
	}
}


/* o"upStreamGrid"ɒl */
void Cell::setUpStreamGrid()
{
	for(int i=0; i<7; i++){
		
		if(downStreamGrid->upStreamGrid[i]==NULL){
			downStreamGrid->upStreamGrid[i]=this;
			break;
		}
		
	}
}

/* 㗬Obh̐𐔂 */
void Cell::countNumberOfUpStreamGrid()
{
	numberOfUpStreamGrid = 0;
	
	for(int i=0; i<7; i++){

		if(upStreamGrid[i]!=NULL){
			numberOfUpStreamGrid++;
		}
		else{
			break;
		}
	}
	
}

/* ̃Obh܂܂ROFZ߂ */
void Cell::setROFCell(ROF** fROF, int row_ROF, int col_ROF)
{
	double x=(double)latitude/3600.0;
	double y=(double)longitude/3600.0;
	double distance;
	double distance_min;

	distance_min=100000000000000000000000000000.0;
	
	for(int i=0; i<row_ROF; i++){
		for(int j=0; j<col_ROF; j++){

			distance = sqrt(pow(x-(double)fROF[i][j].latitude, 2.0)+pow(y-(double)fROF[i][j].longitude, 2.0));
			
			if(distance < distance_min){
				
				ROFCell=&fROF[i][j];
				distance_min = distance;
			}
		}
	}
}


/* ovZ */
/* p^̐ݒ */
void Cell::Set_parameter(double wMan_channel, double wMan_slope, double wKa, double wDa, double wDm, double wBeta, int wthre_basin, int x_Div, int t_Div, double theta, int t_step_num, int Ndays)
{

	switch(down){
	case 1:	mL = 926.6;
		break;
		
	case 2:	mL = sqrt(pow(926.6, 2.0) + pow((double)longitudinalLength, 2.0));
		break;
		
	case 3:	mL = longitudinalLength;
		break;
		
	case 4: mL = sqrt(pow(926.6, 2.0) + pow((double)longitudinalLength, 2.0));
		break;
		
	case 5: mL = 926.6;
		break;
		
	case 6: mL = sqrt(pow(926.6, 2.0) + pow((double)longitudinalLength, 2.0));
		break;
		
	case 7: mL = longitudinalLength;
		break;
		
	case 8: mL = sqrt(pow(926.6, 2.0) + pow((double)longitudinalLength, 2.0));
		break;

	case 0: mL = sqrt(pow(926.6, 2.0) + pow((double)longitudinalLength, 2.0));
		break;
		
	default: break;
	}	

	if(downStreamGrid!=NULL){ 
		
		mG = tan((med - downStreamGrid->med) / mL);

		//if(mG < 0.001) mG = 0.001;
		if(mG < 0.00001) mG = 0.00001;

	}
	else{
		//mG = (float)0.001;
		mG = (float)0.001;		
	}
	mG = atan(mG); mG = sin(mG); // sin̒lɕϊ

	mthre_basin = wthre_basin; // EWʐ
	mDiv = x_Div;
	mDx = mL / mDiv;
	mDt = t_Div;
	mTheta = theta; 
	mQc = new double[mDiv+1];
	mQn = new double[mDiv+1];

	mQn_memory = new float**[Ndays];
	for(int i=0; i < Ndays; i++){
		mQn_memory[i] = new float*[24];
	}
	for(int i=0; i < Ndays; i++){
		for(int j=0; j<24; j++){
			mQn_memory[i][j] = new float[t_step_num];
		}
	}
	for(int i=0; i < Ndays; i++){
		for(int j=0; j<24; j++){
			for (int k=0; k<t_step_num; k++) {
				mQn_memory[i][j][k] = 0.0;
			}
		}
	}

	mZ = 1.0;//ʗϊ֌Ŵ߂̃p[^
	mM = 1.0 + 0.666667 * mZ;//ʗϊ֌Ŵ߂̃p[^
	// setting parameters
	if(basin > mthre_basin) {//setting parameters in channel
		double para_a, para_m; // parameter for setting channel width
		para_a = 1.061722301;
		para_m = 0.685081138;
		//width is determined by emperical formula in channel
		mB = para_a * pow((basin * 926.6/1000.0 * longitudinalLength/1000.0), para_m);

		mMan_channel   =  wMan_channel; // ͓̑exW
		mK = 1.0 / mB;
		mAlpha_channel = 1.0 / mMan_channel * pow(mK, mM-1.0) * sqrt(mG);
	}
	else {//setting parameters in slope
		//width is determined as grid width in basin
		mB = 926.6 * longitudinalLength / mL;

		mMan_slope   =  wMan_slope; // Ζʕ̑exW
		mKa   =  wKa; // Oaw̓W
		//mD   =  wD; // yw
		mDa   =  wDa; // Oaw
		mDm   =  wDm; // sOaw
		mBeta   =  wBeta; // sOax\w
		mVa = mKa * mG; // Oaw̗
		mAlpha_slope = sqrt(mG) / mMan_slope;
	}

}
//ʂ̏
void Cell::initialize(double ini_lateral)
{
	double up_iniQ;
	double down_iniQ;

	up_iniQ = ini_lateral * 0.001 / 3600 * (basin-1) * 926.6*longitudinalLength;
	down_iniQ = ini_lateral * 0.001 / 3600 * basin * 926.6*longitudinalLength;
	
	
	for(int i=0; i<mDiv+1; i++){
		mQc[i] = (up_iniQ * (mDiv - i) + down_iniQ * i) / mDiv;
		mQn[i] = (up_iniQ * (mDiv - i) + down_iniQ * i) / mDiv;
	}

	mQlc = ini_lateral * 0.001 *  926.6 * longitudinalLength / mL / 3600.0;
	mQln = ini_lateral * 0.001 *  926.6 * longitudinalLength / mL / 3600.0;
}

/* ʂ𓾂 */
void Cell::getLateralRunoff(int n_day, int n_hour)
{
	int c_day, c_hour;
	c_day   = n_day;	
	c_hour  = n_hour - 1;
	
	if(c_hour == 0){

		c_hour = 24;
		c_day--;
	}

	mQlc = ROFCell->value[c_day][c_hour-1];
	mQln = ROFCell->value[n_day][n_hour-1];

	//[mm/hr]-->[m2/s]
	mQln = mQln * 0.001 *  926.6 * longitudinalLength / mL / 3600.0;
	mQlc = mQlc * 0.001 *  926.6 * longitudinalLength / mL / 3600.0;

}

/* vZ */
// calculate runoff for 1 hour  ͓1ԕ̗ovZD͓ƎΖʂ̌vZʂ̊֐ōsD
void Cell::CalculateRiver(int day, int hour, int nt)
{
	double dt = (double)mDt;
	double wC = 0.0;//`dx

	// lateral flow intensity.  (m2/s)
	double wQl = 0.5 * (mQlc + mQln); // mean value last one hour
	//double wQl = mQlc; // mQlc: previous 1 hour mean data
	//double wQl = mQln; // mQln: current 1 hour mean data

	// inflow from upstream 㗬[̗ (m3/s)
	double wUpInflow = 0.0;
	for(int i=0; i<numberOfUpStreamGrid; i++){
		// 㗬ɐڑObh̉[̗ʂZbg
		wUpInflow += (double)(upStreamGrid[i]->mQn_memory[day-1][hour-1][nt]); 
	}

	mQn[0] = wUpInflow; // ^[Qbg̏[痬闬

	for (int i = 1; i <= mDiv; i++) {
		//double wCa = mAlpha_channel*mM*pow(mAc[i-1], mM-1.0);
		double wCa = pow(mAlpha_channel, 1.0/mM) * mM * pow(mQc[i-1], (mM-1.0)/mM);

		double wQ = max(mQc[i], 0.5*(mQc[i-1]+mQn[i-1])+wQl*mDx);
		double wCb = pow(mAlpha_channel, 1.0/mM) * mM * pow(wQ, (mM-1.0)/mM);

		wC = 0.5 * (wCa + wCb);

		// ^[Qbg̊evZfʂł̗
		mQn[i] = (mQc[i] + mTheta * wC * (dt/mDx * mQn[i-1] + dt * wQl) 
			- (1. - mTheta) * wC * dt * ((mQc[i] - mQc[i-1])/mDx - wQl)) 
			/ (1. + mTheta * wC * dt / mDx);

		if (mQn[i] < 0.0) {
			mQn[i] = 0.0;
		}
	}

	// vZΖʉ[̗ʂL
	mQn_memory[day-1][hour-1][nt] = (float)mQn[mDiv];

	// update discharge and water depth ԗʂ̍XV
	for (int i=0; i <= mDiv; i++) {
		mQc[i] = mQn[i];
	}
	mQlc = mQln;

}

// calculate runoff for 1 hour  Ζʂ1ԕ̗ovZD͓ƎΖʂ̌vZʂ̊֐ōsDby Tanaka 2012/11/7
void Cell::CalculateBasin(int day, int hour, int nt)
{
	double dt = (double)mDt;
	double mQlevel = 1.0;// ʂ̌vZl̊l (mm/hour)
	double mEps = 0.001;// vZx̕Wl
	double mQsmall = mQlevel * mEps * 0.001 / 3600.;//(mm/hour)-->(m/s)
	double mQeps = mQsmall * mDx;//(m^2/s)
	double wC = 0.0;//`dx
	double mCmin = 0.000001; // `dx̍ŏl (m/s)

	// lateral flow intensity.  (m2/s)
	double wQl = 0.5 * (mQlc + mQln); // mean value last one hour
	//double wQl = mQlc; // mQlc: previous 1 hour mean data
	//double wQl = mQln; // mQln: current 1 hour mean data

	// 㗬[̗ (m3/s)
	double wUpInflow = 0.0;
	for(int i=0; i<numberOfUpStreamGrid; i++){
		// 㗬ɐڑObh̉[̗ʂZbg
		wUpInflow += (double)(upStreamGrid[i]->mQn_memory[day-1][hour-1][nt]); 
	}
	mQn[0] = wUpInflow; // ^[Qbg̏[痬闬 (m3/s)

	for (int i = 1; i <= mDiv; i++) {

		// sOaEOaԗE\ʗlLl}eBbNEF[ufł̓`dx
		double q = 0.5*(mQc[i]+mQc[i-1]) / mB;// (m2/s)  // method 1
		//double q = 0.5*(mQc[i-1]+mQn[i-1]) / mB;// (m2/s)  // method 2
		//double q = max(mQc[i], 0.5*(mQc[i-1]+mQn[i-1])+wQl*mDx)/mB;  // method 3
		//double q = 0.5*(mQc[i] + 0.5*(mQc[i-1]+mQn[i-1])+wQl*mDx)/mB;  // method 4
		//double q = 0.5*(0.5*(mQc[i-1]+mQc[i])+mQn[i-1]) / mB;// (m2/s)  // method 5
		//double q = (mQc[i-1]+mQc[i-1]+mQn[i-1])/3.0/mB;// (m2/s)  // method 6

		//double qold; // test

		//for (int itl=0; itl < 10; itl++) { // test

		if (q < mVa/mBeta * mDm) { //}gNX̏ꍇ
			double h = pow(q*mBeta/(mVa*mDm),1/mBeta) * mDm;
			wC = mVa * pow(h/mDm , mBeta - 1.);
		}
		else if (q < mVa * (mDa - mDm) + mVa/mBeta * mDm) { // }gNXEԗ̏ꍇ
			wC = mVa;
		}
		else { // \ʗĂꍇ
			double h0 = mDa + pow(((q - (mVa*(mDa-mDm) + mVa/mBeta*mDm))/mAlpha_slope),1./mM);
			double v0 = pow(h0-mDa, mM - 1.);
			double q0 = mAlpha_slope * v0 * (h0-mDa) + mVa * (h0-mDm) + mVa/mBeta * mDm;
			double q1;
			int count=0;
			while (1)
			{
				h0 = h0 - (q0 - q)/(mAlpha_slope * mM * v0 + mVa);
				v0 = pow(h0 - mDa, mM - 1.);
				q1 = mAlpha_slope*v0*(h0-mDa) + mVa*(h0-mDm) + mVa/mBeta*mDm;
				if (fabs(q1 - q0) < mQeps) break;
				q0 = q1;
				if(count>10000){
					cout << "Warning at PropagationSpeed.\n" << endl;
					cout << "C : " << wC << endl;
					wC = mCmin;
					break;
				}
				count+=1;
			}

			wC = mAlpha_slope * mM * v0 + mVa;
		}
		if (wC < mCmin) wC = mCmin; // `dx 0 ƂȂȂ悤ɂĂB

		// ^[Qbg̊evZfʂł̗
		mQn[i] = (mQc[i] + mTheta * wC * (dt/mDx * mQn[i-1] + dt * wQl) 
			- (1. - mTheta) * wC * dt * ((mQc[i] - mQc[i-1])/mDx - wQl)) 
			/ (1. + mTheta * wC * dt / mDx);

		if (mQn[i] < 0.0) {
			mQn[i] = 0.0;
		}
		//qold = q; // test
		//q = 0.25*(mQc[i-1] + mQc[i] + mQn[i-1] + mQn[i])/mB; // test

		//}// test

	}

	// vZΖʉ[̗ʂL
	mQn_memory[day-1][hour-1][nt] = (float)mQn[mDiv];

	// update discharge ԗʂ̍XV
	for (int i=0; i <= mDiv; i++) {
		mQc[i] = mQn[i];
	}
	mQlc = mQln;
}

float Cell::GetHourlyFlow(int day, int hour, int t_step_num) {
	// return hourly flow calculated by hourly data. Coded by YT.
	float hourlyflow=0;
	for(int k=0; k < t_step_num; k++){

		hourlyflow = hourlyflow + mQn_memory[day][hour][k];

	}
	hourlyflow = hourlyflow/t_step_num;
	return (hourlyflow);
}

float Cell::GetDailyFlow(int day, int t_step_num) {
	// return daily flow calculated by hourly data. Coded by Hunu.
	float dailyflow=0;
	int hour;
	for(hour=0; hour<24; hour++){
		float hourlyflow=0;
		for(int k=0; k<t_step_num; k++){

			hourlyflow = hourlyflow + mQn_memory[day][hour][k];

		}
		hourlyflow = hourlyflow/t_step_num;
		dailyflow = dailyflow + hourlyflow;
	}
	dailyflow = dailyflow/24;
	return (dailyflow);
}

float Cell::GetHourlyFlowMax(int day, int t_step_num) {
	// return hourly maxumum flow in a day. Coded by Hunu.
	float hourlyflowMax=0;
	int hour;
	for(hour=0; hour<24; hour++){
		float hourlyflow=0.0;
		for(int k=0; k<t_step_num; k++){
			
			hourlyflow = hourlyflow + mQn_memory[day][hour][k];
			
		}
		hourlyflow =  hourlyflow/t_step_num;
		
		if (hourlyflow >= hourlyflowMax){
			hourlyflowMax = hourlyflow;
		}
	}
	return (hourlyflowMax);
}


void Cell::deleteQandA(int Ndays)
{
	delete[] mQc;
	delete[] mQn;

	for(int i=0; i<Ndays; i++){
		for(int j=0; j<24; j++){
			
			delete[] mQn_memory[i][j];
		}
	}
	for(int i=0; i<Ndays; i++){
		
		delete[] mQn_memory[i];
	}
	delete[] mQn_memory;

}



// Below is function settings for dam reservoir ȉ̓_fɊւ֐

// set initial condition of dam
void damCell::setDamGrid(
	int wDamRow, // _Obḧʒu̎w from West starting from 1
	int wDamCol, // _Obḧʒu̎w from South starting from 1
	int Row, // Ώۗ̈̍s
	int Col, // Ώ̗ۗ̈
	int damID, // _̎ʔԍ 90 ԑƂB
	class Cell** cell, // _ݒ肷Obh̃|C^
	int wDamSimulationKind // 0: use observed dam outflow, 1: use dam model 
)
{
	damRow = Row - wDamRow; // converting from North starting from 0.
	damCol = wDamCol-1; //  converting from West starting from 0.
	damSimulationKind = wDamSimulationKind; // 0: use observed dam outflow, 1: use dam model
	damGrid = &cell[damRow][damCol];
	damGrid->gridKind = damID;
}


// set initial state variables
void damCell::setDamInitialState(double wStorage)
{
	storage = wStorage; // setting initial storage
}

// set dam model parameters
void damCell::setDamParameter(double wa)
{
	a = wa; // set parameter a
}


// read obserbed 1 month dam outflow
void damCell::readDamOutflow(int nday, int t_step_num)
// _ʂт̃f[^ɒu邽߂̊֐B
// Pʂ̃f[^ǂݍގdlƂȂĂ̂ŏCKvłB
{

	if (damSimulationKind != 0) {
		cout << " Not use dam outflow observed data." << endl;
		return;
	}

	int whour, wday;
	float damOutflow;
	char damOutflowFileNamebin[256];

	// Reading daily dam outflow data
	//sprintf(damOutflowFileNamebin, "./input/damOutflow61-15.dat");
	sprintf_s(damOutflowFileNamebin, 256, "./input/damOutflow61-15.dat");
	ifstream fin(damOutflowFileNamebin);
	if (!fin) {
		cout << "Dam outflow file cannot open.\n";
		exit(1);
	}

	// set row and col of dam grid. row begins from south; col begins from west.
	// starting number is 1.

	for (int iday=0; iday < nday; iday++) {  // day loop
		for (int ihour=0; ihour < 24; ihour++) { // hour loop
			fin >> wday >> whour >> damOutflow; // read hourly dam outflow data
			//cout << " outflow = " << damOutflow << endl;
			for(int k=0; k < t_step_num; k++) {  // 1ԓ̌vZXebvJԂB
				damGrid->mQn_memory[iday][ihour][k] = damOutflow;  // ****Kv
			}
		}
	}
	cout << " read input dam outflow data: " << damOutflowFileNamebin << endl;

	fin.close();
}


// calculate dam outflow for 1 hour
//void damCell::calculateDamOutflow(int imonth, int day, int hour)
void damCell::calculateDamOutflow(int day, int hour, int nt)
{

	if (damSimulationKind == 0) { // use dam outflow observed data. у_ʂgꍇBɕԂB
		return;
	}
	
	double damOutflow; // outflow from dam (m3/s)
	double wUpInflow; // total inflow to dam (m3/s)

	wUpInflow = 0.0; // total inflow to dam (m3/s)

	// inflow from upstream 㗬[̗ (m3/s)
	for(int i=0; i < damGrid->numberOfUpStreamGrid; i++){
		// 㗬ɐڑObh̉[̗ʂZbg
		// setting inflow from upper grids
		wUpInflow += (double)(damGrid->upStreamGrid[i]->mQn_memory[day-1][hour-1][nt]); 
	}
	
	// add raleral inflow
	// lateral flow intensity.  (m3/s)
	wUpInflow += (damGrid->mQln) * (damGrid->mL); 

	damOutflow = a*wUpInflow;

	damGrid->mQn_memory[day-1][hour-1][nt] = (float)damOutflow; 
}


